<?php

if( eregi( "functions.php", $_SERVER['PHP_SELF'] ) ) {
    die_custom( "You can't access this file directly!" );
}

# Functions for Collaborative Online Docs    

include "config.php";
include "menu.php";


# --------------------------------------------------
# Print stuff

function print_content( $docID, $docversionID ) {
    
    $content = get_content( $docID, $docversionID );
    
    $content = RTESafe( $content );
    
    print $content;
    
}

# print_options
#
# Print a series of HTML options (to go in a <choice> tag).
#
# Parameters:
#   $query   a query with 2 output fields that give the ID and contents of
#            each option
#   $ID      the ID of the selected option (or -1 for none)
#
function print_options( $query, $ID ) {
    
    $result = run_query( $query );
    
    if( !$ID ) {
    
        print "<option value='' selected>Choose...</option>\n";
        
    }
    
    while( $row = mysql_fetch_row( $result ) ) {
        
        $this_ID   = $row[0];
        $this_name = $row[1];
        
        print "<option ";
        
        if( $ID == $this_ID ) {
            print "selected ";
        }
        
        print "value='$this_ID'>$this_name</option>\n";
        
    }
    
    mysql_free_result( $result );
    
}

function print_options_styles( $ID ) {
    
    $username = get_username();
    
    print_options( "SELECT ID, name from style "
        ."WHERE username = \"$username\" "
        ."ORDER BY name", $ID );
    
}

# --------------------------------------------------
# Send email

function send_email( $docname, $realname, $comment, $docID ) {
    global $site_name, $web_root;
    
    $docname      = get_docname( $docID );
    $email_recips = $_POST{'email_recips'};
    
    $mail_ok = mail( $email_recips, "$site_name - $docname changed",
        "$site_name\n\nThe page \"$docname\" has been changed by $realname, who left this comment:\n\n$comment\n\nYou can view and edit the page here:\n\n$web_root/index.php?docID=$docID\n\n",
        "From:andybalaam@artificialworlds.net" );
        
    if( !$mail_ok ) {
     
        return( 'Unable to send notification email!' );
        
    }
     
}


function assure_numeric( $num ) {
    
    if( !is_numeric( $num ) ) {
        
        die_custom( "Error!  Non-numeric ID ($num) found." );
        
    }
    
}

# --------------------------------------------------
# MySQL functions
# --------------------------------------------------

# print_query_results2
#
# General function for printing the results of a query formatted in a
# specific way.
#
# parameters:
#    $format        a string like "first: $1,   second:$2" that show how to print
#               the results of the query
#    $query      the query that has 2 output fields
#               (e.g. "SELECT firstname, secondname FROM table")
#
# The above examples would produce this kind of output:
# first: Andy    second: Balaam
# first: Ian     second: Macinnes
# first: Bill    second: Gates
#
function print_query_results2( $format, $query ) {
    
    $result = run_query( $query );
    
    while( $row = mysql_fetch_row( $result ) ) {
        
        $text = preg_replace( '/\$1/', $row[0], $format );
        $text = preg_replace( '/\$2/', $row[1], $text );
        
        print $text;
        
    }
    
    
}

# Get an array of all the versions of this page
function get_versions( $docID ) {
    
    if( !doc_exists( $docID ) ) {
        return 0;
    }

    $result = run_query(
        'SELECT ID,timestamp,content,comment,realname,styleID '
        ."FROM doccontent WHERE docID = $docID ORDER BY ID DESC" )
    or die_custom( "No content found for id $docID" );
    
    while( $row = mysql_fetch_row( $result ) ) {
        
        $ans[] = $row; 
        
    }
    
    return $ans;
    
}

# --------------------------------------------------
# Vars

function get_username() {
    
    //return $_SERVER['PHP_AUTH_USER'];
    
	return "andy";
    
}

# Find all the page's details from the docID supplied
function get_all_doc_properties( $docID,
        &$docname,  &$docfilename, &$styleID,
        &$realname, &$email_recips ) {
    
    if( !doc_exists( $docID ) ) {
        
        return "Page does not exist!";
        
    }
    
    $username = get_username();
    
    $result = run_query( "SELECT name, filename, realname, "
        ."email_recips FROM doc WHERE ID = $docID "
        ."AND username = \"$username\"" );
    
    $row = mysql_fetch_row( $result );
    
    mysql_free_result( $result );
    
    $docname      = $row[0];
    $docfilename  = $row[1];
    $realname     = $row[2];
    $email_recips = $row[3];
    
    $styleID = get_styleID( $docID );
    
}

# Find this user's oldest page's ID
function get_first_docID() {
    
    $username = get_username();
    
    $result = run_query( "SELECT ID FROM doc WHERE username =\"$username\" "
        ."ORDER BY ID LIMIT 1" );
    
    $row = mysql_fetch_row( $result );
	
    mysql_free_result( $result );
    
    return $row[0];
    
}

# Individual property getters
function get_docname( $docID ) {
    return get_doc_property( 'name', $docID );
}
function get_realname( $docID ) {
    return get_doc_property( 'realname', $docID );
}
function get_email_recips( $docID ) {
    return get_doc_property( 'email_recips', $docID );
}
function get_docfilename( $docID ) {
    return get_doc_property( 'filename', $docID );
}

function get_cssfile_for_styleID( $styleID ) {
    global $web_root;
    
    $username = get_username();
    
    $result = run_query( "SELECT cssfile FROM style WHERE ID = $styleID "
        ."AND username = \"$username\"" );
    
    $row = mysql_fetch_row( $result );
    
    mysql_free_result( $result );
    
    return $web_root."/".$row[0].".css";
    
}

function get_cssfile( $docID ) {
    
    $styleID = get_styleID( $docID );
    
    return get_cssfile_for_styleID( $styleID );
    
}

function get_doccontent( $docID ) {
    return get_doccontent_property( 'content', $docID );
}
function get_styleID( $docID ) {
    return get_doccontent_property( 'styleID', $docID );
}

# ---

function get_doc_property( $property, $docID ) {
    
    if( !doc_exists( $docID ) ) {
        return "";
    }
    
    $username = get_username();
    
    $result = run_query( "SELECT $property FROM doc WHERE ID = $docID "
        ."AND username = \"$username\"" );
    
    $row = mysql_fetch_row( $result );
    
    mysql_free_result( $result );
    
    return $row[0];
    
}

function get_doccontent_property( $property, $docID ) {
    
    if( !doc_exists( $docID ) ) {
        return "";
    }
    
    $result = run_query( "SELECT $property FROM doccontent "
        ."WHERE docID = $docID ORDER BY ID DESC" );
    
    $row = mysql_fetch_row( $result )
    or die_custom( "No content found for page id $docID" );
    
    mysql_free_result( $result );
    
    return $row[0];
    
}

# ---

# Return true if $docID is non-null and the page exists for this user in
# the database.
function doc_exists( $docID ) {
    
    $ans = true;
    
    # Check the id is non-null and numeric
    if( !$docID || !is_numeric( $docID ) ) {
        
        $ans = false;
        
    } else {
    
        $username = get_username();
    
        $result = run_query( "SELECT ID FROM doc "
            ."WHERE ID = $docID AND username = \"$username\"" );
    
        # Check for a bad query
        if( !$result ) {
            
            $ans = false;
        
        } else {
            
            $row = mysql_fetch_row( $result );
            
            # Check for no rows
            if( !$row ) {
                $ans = false;
                
            }
            
        }
        
        mysql_free_result( $result );
        
    }
    
    return $ans;
    
}

# Get the content of the page (either latest version or the one specified)
function get_content( $docID, $docversionID ) {
    
    if( !doc_exists( $docID ) ) {
        die_custom( "Page doesn't exist!" );
    }
    
    if( $docversionID && is_numeric( $docversionID ) ) {
    
        $query = "SELECT content FROM doccontent WHERE docID = $docID "
            ."AND ID = $docversionID";
        
    } else {
        
        $query = "SELECT content FROM doccontent WHERE docID = $docID "
            .'ORDER BY ID DESC LIMIT 1';
        
    }
    
    $result = run_query( $query );
    
    $row = mysql_fetch_row( $result );
    
    mysql_free_result( $result );
    
    $ans = $row[0];
    
    return $ans;
    
}

# ----------------------------------------
# Main page functions

function edit_doc( $newdocID ) {
    
    $newdocversionID = $_GET{'newdocversionID'};
	
    if( doc_exists( $newdocID ) ) {
    
    ?>

        <form name="collabform" id="collabedit" action="save.php?newdocID=<? print $newdocID ?>" method="post" onsubmit="return submitForm();">

        <input type="hidden" name="docID" value='<? print $newdocID ?>' />
    
        <script language="JavaScript" type="text/javascript">
        <!--

        initRTE("images/", "", "");

        writeRichText( 'doccontent', '<?
            print_content( $newdocID, $newdocversionID );
        ?>', '100%', '70%', true, false, '<?
            print get_cssfile( $newdocID )
        ?>' );
        
        -->
        </script>
        <noscript><p><b>Javascript must be enabled to use this page.</b></p></noscript>
    
        </form>
    
    <?php

    } else {
        
        return "That page doesn't exist!";
        
    }
    
}

# Delete a page
function delete_doc( $docID ) {
    
    $sure  = $_POST{'sure'};
    
    if( !$sure ) {
        
        die_custom( "Didn't delete page since you didn't tick "
            .'the box saying you were sure.' );
        
        return;
        
    }
    
    if( !doc_exists( $docID ) ) {
        die_custom( "That page doesn't exist!" );
    }
    
    $docname = get_docname( $docID );
    
    run_query( "DELETE FROM doccontent WHERE docID = $docID" )
    or die_custom( 'Failed to delete page content.' );
        
    run_query( "DELETE FROM doc WHERE ID = $docID" )
    or die_custom( 'Failed to delete page.' );
    
}

# Save a page
function save_doc( $docID, $docname ) {
    
    $doccontent = $_POST{'doccontent'};
    $realname   = $_POST{'realname'};
    $comment    = $_POST{'comment'};
    $styleID    = $_POST{'styleID'};
    $notify     = $_POST{'notify'};
    
    if( !doc_exists( $docID ) ) {
        return( 'That page does not exist.' );
    }
    
    $doccontent = mysql_escape_string( stripslashes( $doccontent ) );
    $realname   = mysql_escape_string( stripslashes( $realname   ) );
    $comment    = mysql_escape_string( stripslashes( $comment    ) );
    
    assure_numeric( $styleID );
    
    $result = run_query( 'INSERT INTO doccontent '
            .'( docID, timestamp, content, realname, comment, styleID ) '
            ."VALUES( $docID, NULL, \"$doccontent\", \"$realname\","
            ."\"$comment\", $styleID )" );
    
    if( !$result ) {
        return( 'Failed to save page.' );
    }
    
    if( $notify ) {
        
        return send_email( $docname, $realname, $comment, $docID );
        
    }
    
    
}

# Save the old page transparently if it has been changed
function autosave_doc_if_needed( $docID ) {
    global $db_connect;

    $doccontent = stripslashes( $_POST{'doccontent'} );
    
    # If we've got an old page and it's different from the latest
    # saved version
    if( $docID ) {
        
        if( strcmp( $doccontent, get_content( $docID, false ) ) != 0 ) {
        
            //print "<!--Page autosaved.-->\n";
        
            # Then save it
        
            $username   = get_username();
            $doccontent = mysql_escape_string( $doccontent );
            $username   = mysql_escape_string( stripslashes( $username   ) );
            $comment    = "(autosave)";
            $styleID    = get_styleID( $docID );
        
            assure_numeric( $styleID );
        
            $result = run_query( 'INSERT INTO doccontent '
                .'(docID, timestamp, content, realname, comment, styleID) '
                ."VALUES( $docID,NULL, \"$doccontent\", \"$username\", "
                ."\"$comment\", $styleID )" );
            
            if( !result ) {
                return mysql_error( $db_connect );
            }
        } else {
            
            return "No need to save: file has not been changed.";
            
        }
        
    } else {
        return "No page specified!";
    }
    
}

function saveas_doc() {
    global $db_connect;
    
    $olddocID    = $_POST{'docID'};
    $docname     = $_POST{'docname'};
    $doccontent  = $_POST{'doccontent'};
    $docfilename = $_POST{'docfilename'};
    $realname    = $_POST{'realname'};
    $comment     = $_POST{'comment'};
    $notify      = $_POST{'notify'};
    $email_recips= $_POST{'email_recips'};
    $username    = get_username();
    
    if( !doc_exists( $olddocID ) ) {
        die_custom( "Original page doesn't exist!" );
    }
    
    $styleID     = get_styleID( $olddocID );
    
    assure_numeric( $styleID );
    
    $docname     = mysql_escape_string( stripslashes( $docname ) );
    $doccontent  = mysql_escape_string( stripslashes( $doccontent ) );
    $docfilename = mysql_escape_string( stripslashes( $docfilename ) );
    $username    = mysql_escape_string( stripslashes( $username ) );
    $realname    = mysql_escape_string( stripslashes( $realname ) );
    $comment     = mysql_escape_string( stripslashes( $comment ) );
    $email_recips= mysql_escape_string( stripslashes( $email_recips ) );
    
    run_query( "INSERT INTO doc (username, realname, name, filename, "
        ."email_recips ) VALUES ( "
        ."\"$username\", \"$realname\", \"$docname\", \"$docfilename\", "
        ."\"$email_recips\" )" );
    
    $docID = mysql_insert_id( $db_connect );
    
    assure_numeric( $docID );
    
    $result = run_query( 'INSERT INTO doccontent '
            .'(docID, timestamp, content, realname, styleID, comment) '
            ."VALUES ($docID, NULL, \"$doccontent\","
            ."\"$realname\", $styleID, \"$comment\") " );
    
    standard_header( $docname );
    menu( $docID );
    
    $edit_error = edit_doc( $docID );
    
    if( $result ) {
        $olddocname = get_docname( $olddocID );
        status_bar( "New page \"$docname\" created as a copy of \"$olddocname\"." );
    } else {
        status_error( 'Failed to create a new page: '
            .mysql_error( $db_connect ).'.' );
    }
    
    if( $edit_error ) {
        status_error( $edit_error );
    }
    
    if( $notify ) {
        
        $email_error = send_email( $docname, $realname, $comment, $docID );
        
        if( $email_error ) {
            status_error( $email_error );
        }
        
    }
    
    standard_footer();
    
}

# Change the properties of a page
function change_properties() {
    global $db_connect;
    
    $docID        = $_POST{'docID'};
    $docname      = $_POST{'docname'};
    $doccontent   = get_doccontent( $docID );
    $docfilename  = $_POST{'docfilename'};
    $realname     = $_POST{'realname'};
    $comment      = $_POST{'comment'};
    $notify       = $_POST{'notify'};
    $email_recips = $_POST{'email_recips'};
    $styleID      = $_POST{'styleID'};
    $username     = get_username();
    
    if( !doc_exists( $docID ) ) {
        die_custom( "Page doesn't exist!" );
    }
    
    assure_numeric( $styleID );
    
    $docname     = mysql_escape_string( stripslashes( $docname ) );
    $doccontent  = mysql_escape_string( stripslashes( $doccontent ) );
    $docfilename = mysql_escape_string( stripslashes( $docfilename ) );
    $username    = mysql_escape_string( stripslashes( $username ) );
    $realname    = mysql_escape_string( stripslashes( $realname ) );
    $comment     = mysql_escape_string( stripslashes( $comment ) );
    $email_recips= mysql_escape_string( stripslashes( $email_recips ) );
    
    run_query( "UPDATE doc SET username=\"$username\", "
        ."realname=\"$realname\", "
        ."name=\"$docname\", "
        ."filename=\"$docfilename\", "
        ."email_recips=\"$email_recips\" "
        ."WHERE ID = $docID" );
    
    $result = run_query( 'INSERT INTO doccontent '
        .'(docID, timestamp, content, realname, styleID, comment) '
        ."VALUES ($docID, NULL, \"$doccontent\","
        ."\"$realname\", $styleID, \"$comment\") " );
    
    standard_header( $docname );
    menu( $docID );
    
    $edit_error = edit_doc( $docID );
    
    if( $result ) {
        $olddocname = get_docname( $olddocID );
        status_bar( "Properties of \"$docname\" saved." );
    } else {
        status_error( 'Failed to save properties: '
            .mysql_error( $db_connect ).'.' );
    }
    
    if( $edit_error ) {
        status_error( $edit_error );
    }
    
    if( $notify ) {
        
        $email_error = send_email( $docname, $realname, $comment, $docID );
        
        if( $email_error ) {
            status_error( $email_error );
        }
        
    }
    
    standard_footer();
    
}

# Make a new page
function new_doc() {
    global $db_connect;
    
    $docname     = $_POST{'docname'};
    $docfilename = $_POST{'docfilename'};
    $realname    = $_POST{'realname'};
    $styleID     = $_POST{'styleID'};
    $comment     = $_POST{'comment'};
    $email_recips= $_POST{'email_recips'};
    $username    = get_username();
    
    if( !$docname ) {
        die_custom( 'You need to give a name for your new page.' );
    }
    
    assure_numeric( $styleID );
    
    $docname     = mysql_escape_string( stripslashes( $docname ) );
    $docfilename = mysql_escape_string( stripslashes( $docfilename ) );
    $username    = mysql_escape_string( stripslashes( $username ) );
    $realname    = mysql_escape_string( stripslashes( $realname ) );
    $comment     = mysql_escape_string( stripslashes( $comment ) );
    $email_recips= mysql_escape_string( stripslashes( $email_recips ) );
    
    run_query( "INSERT INTO doc (username, realname, name, filename, "
        ."email_recips ) VALUES ( "
        ."\"$username\", \"$realname\", \"$docname\", \"$docfilename\", "
        ."\"$email_recips\" )" );
        
    $docID = mysql_insert_id( $db_connect );
    
    assure_numeric( $docID );
    
    $result = run_query( 'INSERT INTO doccontent '
            .'(docID, timestamp, content, realname, styleID, comment) '
            ."VALUES ($docID, NULL, '<p>Modify your page here.</p>',"
            ."\"$realname\", $styleID, \"$comment\") " );
    
    standard_header( $docname );
    menu( $docID );
    
    $edit_error = edit_doc( $docID );
    
    if( $result ) {
        status_bar( "New page \"$docname\" created." );
    } else {
        status_error( 'Failed to create a new page: '
            .mysql_error( $db_connect ).'.' );
    }
    
    if( $edit_error ) {
        status_error( $edit_error );
    }
    
    standard_footer();
    
}

function set_style( $docID ) {
    
    if( !doc_Exists( $docID ) ) {
        return "Document does not exist.";
    }
    
    $doccontent = get_doccontent( $docID );
    $username = get_username();
    
    $doccontent  = mysql_escape_string( stripslashes( $doccontent ) );
    $username    = mysql_escape_string( stripslashes( $username ) );
    
    $styleID = $_GET{'styleID'};
    
    assure_numeric( $styleID );
    
    $result = run_query( 'INSERT INTO doccontent '
        .'(docID, timestamp, content, realname, styleID, comment) '
        ."VALUES ($docID, NULL, \"$doccontent\","
        ."\"$username\", $styleID, \"(style change)\") " );
    
    if( !$result ) {
        return "Style setting failed!";
    }
    
}

function history( $docID ) {

    $full = $_GET{'full'};

    ?>

    <center>

    <?php if( !$full ) { ?>
        <p><a href="?docID=<? print $docID ?>&amp;full=1">Show full history</a></p>
    <?php } else { ?>
        <p><a href="?docID=<? print $docID ?>">Show brief history</a></p>
    <?php } ?>

    <table>

    <tr>
    <th><br /></th>
    <th>ID</th>
    <th>Date</th>
    <th>Person</th>
    <th>Comment</th>
    <?php if( $full ) { ?>
        <th>Page</th>
    <?php } ?>
    </tr>

    <?php

    $versions = get_versions( $docID );
    
    if( !$versions ) {
        
        $error = "No page found for id \"$docID\".";
        
    } else {
    
        while( list ($key, $version ) = each( $versions ) ) {
        
            $versionID = $version[0];
            $mysql_time = $version[1];
        
            $hour = substr( $mysql_time, 8, 2 );
            $min = substr( $mysql_time, 10, 2 );
            $sec = substr( $mysql_time, 12 );
            $mday = substr( $mysql_time, 6, 2 );
            $mon = substr( $mysql_time, 4, 2 );
            $year = substr( $mysql_time, 0, 4 );
        
            print "<tr>\n";
            print '    <td class="history" style="text-align:center">'
                ."<a href='index.php?newdocID=$docID"
                ."&amp;newdocversionID=$versionID'>"
                ."edit this version</a></td>\n";
                print "    <td class='history'>$version[0]</td>\n";
                print "    <td class='history'>$year-$mon-$mday $hour:$min:$sec"
                ."</td>\n";
                print "    <td class='history'>$version[4]</td>\n";
                print "    <td class='history'>$version[3]</td>\n";
        
            if( $full ) {
            
                ?>
            
                <td class="history"><script language="JavaScript"   type="text/javascript">
                <!--

                initRTE("images/", "", "");

                writeRichText('doccontent', '<?
                    print RTESafe( $version[2] );
                ?>', 200, 100, false, true, '<?
                    print get_cssfile_for_styleID( $version[5] )
                ?>' );

                -->
                </script></td>
            
                <?php
            }
        }
        print "</tr>\n";
    }
    
    ?>

    </table>

    </center>
    
    <?
    
    return $error;
}

# ----------------------------------------
# Database functions

# Connect to the database
function connect_db() {
    global $db_connect, $mysql_user, $mysql_password, $mysql_database;
    
    if( !$db_connect ) {
    
        $db_connect = mysql_connect( $mysql_host, $mysql_user, $mysql_password )
        or die_custom( 'I cannot connect to the database because: '
            .mysql_error() );
        
        if( $mysql_database ) {
        
            mysql_select_db( $mysql_database )
            or die_custom( 'Error selecting database.' );
            
        }
            
    }
    
}

# Disconnect from the database
function disconnect_db() {
    global $db_connect;
    
    mysql_close( $db_connect );
    $db_connect = 0;
    
}

# Run a query
function run_query( $query ) {
    global $db_connect;
    
    connect_db();
    
    $result = mysql_query( $query, $db_connect )
    or die_custom( "Failed to run query '$query': "
        .mysql_error( $db_connect ) );
    
    return $result;
    
}

# --------------------------------------------------
# Publishing functions

function publish_doc( $docID, $docfilename ) {
    global $document_root;
    
    autosave_doc_if_needed( $docID );
    
    $page        = build_published_page( $docID, "" );
    
    $outfile = fopen( "$document_root/$docfilename.html", 'w' );
    
    fwrite( $outfile, $page );
    
    fclose( $outfile );
    
}

function preview() {
    
    $docID = $_POST{'docID'};
    
    autosave_doc_if_needed( $docID );
    
    $page = build_published_page( $docID, "Preview of " );
    
    print $page."<a href='index.php?newdocID=$docID'>Return</a>";
    
}

function build_published_page( $docID, $title_prefix ) {
    
    $doccontent = get_doccontent( $docID );
    $docstyleID = get_styleID( $docID );
    $username   = get_username();
    
    assure_numeric( $docstyleID );
    $username = mysql_escape_string( stripslashes( $username ) );
    
    $result = run_query( "SELECT header, footer FROM style "
        ."WHERE ID = $docstyleID AND username = '$username'" );
    
    $row = mysql_fetch_row( $result );
    
    mysql_free_result( $result );
    
    return user_substitutions( $docID, $row[0].$doccontent.$row[1],
        $title_prefix );
    
}

function user_substitutions( $docID, $text, $title_prefix ) {
    
    $docname = $title_prefix.get_docname( $docID );
    $cssfile = get_cssfile( $docID );
    
    $text = preg_replace( '/\$docname/', $docname, $text );
    $text = preg_replace( '/\$cssfile/', $cssfile, $text );
    
    return $text;
    
}

# --------------------------------------------------
# Admin stuff

function standard_header( $docname ) {
    global $site_name;
    
    $page_title = "$site_name - $docname";

    ?>

    <html>
    <head>

    <title><? print $page_title ?></title>

    <script language="JavaScript" type="text/javascript" src="utils.js"></script>
    <script language="JavaScript1.2" type="text/javascript" src="menu.js"></script>
    <script language="JavaScript" type="text/javascript" src="richtext.js"></script>

    <link rel="stylesheet" type="text/css" href="style.css" />

    </head>

    <body>

    <h1><? print $page_title ?></h1>
    <?
}

function standard_footer() {
    ?>
    
    
    </body>
    </html>
    
    <?
}

function status_bar( $message ) {
    
    print "<p class='status_bar'>$message</p>";
    
}

function status_error( $message ) {
    
    print "<p class='status_error'>$message</p>";
    
}

function die_custom( $message ) {
    
    die( "<p style='color:red'>$message</p>" );
    
}

# --------------------------------------------------

function RTESafe($strText) {
    #returns safe code for preloading in the RTE
    $tmpString = trim($strText);
    
    #convert all types of single quotes
    $tmpString = str_replace(chr(145), chr(39), $tmpString);
    $tmpString = str_replace(chr(146), chr(39), $tmpString);
    $tmpString = str_replace("'", "&#39;", $tmpString);
    
    #convert all types of double quotes
    $tmpString = str_replace(chr(147), chr(34), $tmpString);
    $tmpString = str_replace(chr(148), chr(34), $tmpString);
#    $tmpString = str_replace("\"", "\"", $tmpString);
    
    #replace carriage returns & line feeds
    $tmpString = str_replace(chr(10), " ", $tmpString);
    $tmpString = str_replace(chr(13), " ", $tmpString);
    
    return $tmpString;
}

?>
